Subject: bug#51390: 29.0.50; repeat-mode: Fails to repeat keys in global-map(?)

From: Juri Linkov <[email-masked]>
Date: Mon, 15 Nov 2021 20:54:25 +0200

>>> This is because currently only the last character of the initial
>>> key sequence is allowed to be repeated.  The initial key was "C-n"
>>> and the repeat key is "n" - it's not the same key.  This condition
>>> was added to repeat only such key sequences 'C-x u  u u u ...',
>>> but not 'C-/  u u u u ...'.
>>
>> That explains why I can't repeat C-n, but what makes repeat-mode
>> repeat C-n when at the first line?  That really perplexes me and I'm
>> curious to know the reason.
>
> It seems you found a bug.  When typing C-p at the beginning of the
> buffer it signals an error "Beginning of buffer" (this is correct).
>
> But in this case '(this-command-keys-vector)' used by repeat-mode
> returns [].  This is an unexpected value.

Or maybe this is not a bug: since an error stops executing a keyboard macro,
it makes sense to stop a repeating sequence on error as well
(this logic will be applied after fixing the reported bug).